;@GOTO -)
.MODEL TINY
.386
.CODE
.STARTUP
    ;ES=CS=SS=DS.
    SMSW  AX
    TEST  AL, 1
    JE    RealMode
    MOV   AH, 9
    MOV   DX, OFFSET MustBeReal
    INT   21H
    INT   20H
  MustBeReal DB "Real mode required.",13,10,36
  RealMode:
    SUB   SI, SI
    MOV   SP, 0100H
    MOV   GS, SI
    CLI
    MOV   ECX, GS:[12*4]
    MOV   EDX, GS:[13*4]
    MOV   OrigSS, ECX
    MOV   OrigGP, EDX
    MOV   WORD PTR GS:[12*4], OFFSET NewSS
    MOV   GS:[12*4+2], CS
    MOV   WORD PTR GS:[13*4], OFFSET NewGP
    MOV   GS:[13*4+2], CS

    CLD
    MOV   DWORD PTR [SI-4], 33221100H
    MOV   DWORD PTR [SI-0], 77665544H

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    LODSD SS:[SI]  ;generate #SS (really?)
    NOP
    NOP
    NOP
    NOP
    NOP
    JCXZ  WasException00
    MOV   SSTolerance, CL
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA0H
    CALL  Print
  WasException00:

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    LODSD          ;generate #GP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    JCXZ  WasException01
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA1H
    CALL  Print
  WasException01:

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    MOV   EAX, SS:[SI]  ;generate #SS (really?)
    NOP
    NOP
    NOP
    NOP
    JCXZ  WasException02
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA2H
    CALL  Print
  WasException02:

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    MOV   EAX, [SI]  ;generate #GP
    NOP
    NOP
    NOP
    NOP
    NOP
    JCXZ  WasException03
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA3H
    CALL  Print
  WasException03:


    CMP   SSTolerance, 0
    JE    Quit

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    MOV   SP, AX
    POP   EAX
    NOP
    NOP
    NOP
    NOP
    NOP
    MOV   SP, 0100H
    JCXZ  WasException04
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA4H
    CALL  Print
  WasException04:

    OR    EAX, -1
    MOV   SI, AX
    MOV   CX, AX
    MOV   SP, 3
    INT   11H
    NOP
    NOP
    NOP
    NOP
    NOP
    MOV   SP, 0100H
    JCXZ  WasException05
    MOV   StringEXC, "NN"
    MOV   DX, 0AAA5H
    CALL  Print
  WasException05:


  Quit:
    MOV   ECX, OrigSS
    MOV   EDX, OrigGP
    MOV   GS:[12*4], ECX
    MOV   GS:[13*4], EDX
    STI
    INT   20H

  String    DB "#"
  StringEXC DW 0
            DB " IP="
  StringIP  DB 0,0,0,0
            DB " SI="
  StringSI  DB 0,0,0,0
            DB " EAX="
  StringEAX DB 0,0,0,0,0,0,0,0
            DB 13,10,36

  SSTolerance DB 0

  NewSS:
    MOV   CS:StringEXC, "SS"
    JMP   CommonSSGP
  NewGP:
    MOV   CS:StringEXC, "PG"
  CommonSSGP:
    POP   DX
    CALL  Print
    ADD   DX, 4
    INC   CX
    PUSH  DX
    IRET

Print:
    PUSHF
    PUSHAD
    PUSH  ES
    PUSH  DS
    CLD
    PUSH  CS
    POP   ES
    PUSH  CS
    POP   DS

    MOV   ECX, EAX
    MOV   BX, 8
    MOV   DI, OFFSET StringEAX
  Next0:
    ROL   ECX, 4
    MOV   AL, CL
    AND   AL, 15
    CMP   AL, 10
    JB    Below0
    ADD   AL, 7
  Below0:
    ADD   AL, 48
    STOSB
    DEC   BX
    JNE   Next0

    MOV   CX, DX
    MOV   BX, 4
    MOV   DI, OFFSET StringIP
  Next1:
    ROL   CX, 4
    MOV   AL, CL
    AND   AL, 15
    CMP   AL, 10
    JB    Below1
    ADD   AL, 7
  Below1:
    ADD   AL, 48
    STOSB
    DEC   BX
    JNE   Next1

    MOV   CX, SI
    MOV   BX, 4
    MOV   DI, OFFSET StringSI
  Next2:
    ROL   CX, 4
    MOV   AL, CL
    AND   AL, 15
    CMP   AL, 10
    JB    Below2
    ADD   AL, 7
  Below2:
    ADD   AL, 48
    STOSB
    DEC   BX
    JNE   Next2

    MOV   AH, 9
    MOV   DX, OFFSET String
    INT   21H
    POP   DS
    POP   ES
    POPAD
    POPF
    RET

.DATA
  OrigSS DD ?
  OrigGP DD ?

END

:-)
@ECHO OFF
ML /nologo /c /Gz /Cp /AT /omf SSGP.bat
LINK16 /nologo /TINY SSGP.obj,SSGP.com,NUL,,,
DEL SSGP.obj
PAUSE
CLS
